#=========================================================
# NoiseShakerScript
#
# Blender2.41
# Python Release 2.4.3 29 March 2006
#
# Auther: keina
#
# History:
#   2006.05.02(Tue)  Created
#
# See Also:
#   http://jmsoler.free.fr/didacticiel/blender/tutor/cpl_pythonresizerot.htm
#   http://www.geocities.co.jp/SiliconValley-Cupertino/2019/blender/PythonDocJpn/index.html
#   http://pleac.sourceforge.net/pleac_python/index.html
#   http://blenderartists.org/ http://blenderartists.org/forum/
#   http://www.python.org/  http://www.python.org/doc/
#
# CopyRight(c) 2006 K.Keina
# Mail: keines@ps.sakura.ne.jp
# Web : http://keines.gozaru.jp/blender/
#=========================================================
print '--- NoiseShakerScript.py ---'

import Blender
from Blender import Draw, BGL, Noise

# Other variables
Title		= 'NoiseShakerScript'
Version		= 'ver.2006.05.02(Tue)'
Author		= ' by keines'

# + Cxgԍ
Event_Menu	= 0
Event_Execute	= 1
Event_Exit	= 2
Event_Toggle	= 3
Event_Non	= 100

Menu_Shaker	= 1
Menu_Center	= 2
Menu_Gather	= 3

# + O[oϐ
SpcWidth	= 20
BaseHeight	= 20

# + {^̕
BtnList=[['Execute (X)',0,Event_Execute],['Exit',0,Event_Exit]]
BtnList_Excute	= 0
BtnList_Exit	= 1

BtnList_iStr	= 0
BtnList_iWidth	= 1
BtnList_iEvent	= 2

for i in range(len(BtnList)):
    BtnList[i][BtnList_iWidth]=Draw.GetStringWidth(BtnList[i][BtnList_iStr])+SpcWidth

# + j[֌W
MenuSelect=1
MenuBtn	= Draw.Create(MenuSelect)
MenuName=['Shaker','Center','Gather']
MenuStr='Menu Type %t'
MenuWidth=0
#   - j[̍쐬ƕvZĂ
for i in range(len(MenuName)):
    MenuStr=MenuStr+'|'+MenuName[i]+' %x'+str(i+1)
    k=Draw.GetStringWidth(MenuName[i])
    if MenuWidth<k:MenuWidth=k
MenuWidth+=SpcWidth*2

# + Menu:Shake X,Y,Z gOXC_[
IsShakeDirection=1
ShakeBtn=[[Draw.Create(1),Draw.Create(20),'Loc.X %'],
          [Draw.Create(1),Draw.Create(20),'Loc.Y %'],
          [Draw.Create(1),Draw.Create(20),'Loc.Z %'],
          [Draw.Create(1),Draw.Create(20),'Rot.X %'],
          [Draw.Create(1),Draw.Create(20),'Rot.Y %'],
          [Draw.Create(1),Draw.Create(20),'Rot.Z %']]
ShakeBtn_LX = 0
ShakeBtn_LY = 1
ShakeBtn_LZ = 2
ShakeBtn_RX = 3
ShakeBtn_RY = 4
ShakeBtn_RZ = 5

ShakeBtn_Btn= 0
ShakeBtn_Number=1
ShakeBtn_Str=2
#   - X,Y,Z ̕߂Ă
ShakeBtnWidth=0
for i in range(len(ShakeBtn)):
    k=Draw.GetStringWidth(ShakeBtn[i][ShakeBtn_Str])
    if ShakeBtnWidth<k:ShakeBtnWidth=k
ShakeBtnWidth+=SpcWidth
ShakeNumberWidth=Draw.GetStringWidth('-10000')+SpcWidth*2

# + Menu:Position X,Y,Z gOXC_[
GatherBtnWidth=ShakeBtnWidth
GatherBtn=[[Draw.Create(1),Draw.Create(0.0),'Loc.X'],
         [Draw.Create(1),Draw.Create(0.0),'Loc.Y'],
         [Draw.Create(1),Draw.Create(0.0),'Loc.Z'],
         [Draw.Create(1),Draw.Create(0.0),'Rot.X'],
         [Draw.Create(1),Draw.Create(0.0),'Rot.Y'],
         [Draw.Create(1),Draw.Create(0.0),'Rot.Z']
         ]
GatherBtn_LX	= 0
GatherBtn_LY	= 1
GatherBtn_LZ	= 2
GatherBtn_RX	= 3
GatherBtn_RY	= 4
GatherBtn_RZ	= 5

GatherBtn_Btn	= 0
GatherBtn_Number= 1
GatherBtn_Str	= 2


# + Menu:Position X,Y,Z gOXC_[
CenterBtnWidth=ShakeBtnWidth
CenterBtn=[[Draw.Create(1),Draw.Create(50),'X %'],
           [Draw.Create(1),Draw.Create(50),'Y %'],
           [Draw.Create(1),Draw.Create(50),'Z %']]
CenterBtn_LX	= 0
CenterBtn_LY	= 1
CenterBtn_LZ	= 2

CenterBtn_Btn	= 0
CenterBtn_Number= 1
CenterBtn_Str	= 2
# - _{^
CenterRndBtn = Draw.Create(0)

IsCenterRndDirection=1

#=========================================================
# Functions
#=========================================================

# x Ƃ_l
def GetNoiseRandom(x,percent):
    num=0
    if percent>0: num = ((x * percent)/100) * Blender.Noise.random()
    return num

# IIuWFNgɐU^֐
def ShakerFunction():
    global IsShakeDirection
    for ob in Blender.Object.GetSelected():
        # type.2
        BB= ob.getBoundBox()	# [hԂ̃oEfBO{bNX(8̊p̍W)
        if (ShakeBtn[ShakeBtn_LX][ShakeBtn_Btn].val):ob.LocX+=GetNoiseRandom((BB[-2][0]-BB[0][0]),ShakeBtn[ShakeBtn_LX][ShakeBtn_Number].val)*IsShakeDirection
        if (ShakeBtn[ShakeBtn_LY][ShakeBtn_Btn].val):ob.LocY+=GetNoiseRandom((BB[-2][1]-BB[0][1]),ShakeBtn[ShakeBtn_LY][ShakeBtn_Number].val)*IsShakeDirection
        if (ShakeBtn[ShakeBtn_LZ][ShakeBtn_Btn].val):ob.LocZ+=GetNoiseRandom((BB[-2][2]-BB[0][2]),ShakeBtn[ShakeBtn_LZ][ShakeBtn_Number].val)*IsShakeDirection
        if (ShakeBtn[ShakeBtn_RX][ShakeBtn_Btn].val):ob.RotX+=GetNoiseRandom((BB[-2][0]-BB[0][0]),ShakeBtn[ShakeBtn_RX][ShakeBtn_Number].val)*IsShakeDirection
        if (ShakeBtn[ShakeBtn_RY][ShakeBtn_Btn].val):ob.RotY+=GetNoiseRandom((BB[-2][1]-BB[0][1]),ShakeBtn[ShakeBtn_RY][ShakeBtn_Number].val)*IsShakeDirection
        if (ShakeBtn[ShakeBtn_RZ][ShakeBtn_Btn].val):ob.RotZ+=GetNoiseRandom((BB[-2][2]-BB[0][2]),ShakeBtn[ShakeBtn_RZ][ShakeBtn_Number].val)*IsShakeDirection
    # ƈɂi܂Ȃ̂ŏɔ]Ă
    IsShakeDirection*=-1
    Blender.Redraw()

# IIuWFNgړ֐
def GatherFunction():
    for ob in Blender.Object.GetSelected():
        ob.setEuler(0,0,0)
        if (GatherBtn[GatherBtn_LX][GatherBtn_Btn].val): ob.LocX=GatherBtn[GatherBtn_LX][GatherBtn_Number].val
        if (GatherBtn[GatherBtn_LY][GatherBtn_Btn].val): ob.LocY=GatherBtn[GatherBtn_LY][GatherBtn_Number].val
        if (GatherBtn[GatherBtn_LZ][GatherBtn_Btn].val): ob.LocZ=GatherBtn[GatherBtn_LZ][GatherBtn_Number].val
        if (GatherBtn[GatherBtn_RX][GatherBtn_Btn].val): ob.RotX=GatherBtn[GatherBtn_RX][GatherBtn_Number].val
        if (GatherBtn[GatherBtn_RY][GatherBtn_Btn].val): ob.RotY=GatherBtn[GatherBtn_RY][GatherBtn_Number].val
        if (GatherBtn[GatherBtn_RZ][GatherBtn_Btn].val): ob.RotZ=GatherBtn[GatherBtn_RZ][GatherBtn_Number].val
    Blender.Redraw()

# IIuWFNg̒Sݒ肷֐
# QlURL:http://jmsoler.free.fr/didacticiel/blender/tutor/cpl_pythonresizerot.htm
def CenterFunction():
    for ob in Blender.Object.GetSelected():
        #OB=Blender.Object.GetSelected()[0]
        ME=ob.getData()
        MAT=ob.getMatrix()
        ME.transform(MAT)
        ME.update()
        # LocX,LocY,LocZ ́AIuWFNg̒S̍WŖ{̍WƂ͂܂ʂłB
        # Loc  getLocation Ɠ
        xyz=[ob.LocX,ob.LocY,ob.LocZ]
        # }gbNX
        MAT=Blender.Mathutils.Matrix([1.0,0.0,0.0,0.0],
                                     [0.0,1.0,0.0,0.0],
                                     [0.0,0.0,1.0,0.0],
                                     [0.0,0.0,0.0,1.0])
        # }gbNXݒ
        ob.setMatrix(MAT)
        # Type.2
        BB=ob.getBoundBox()
        # IuWFNg̊pW
        CU= [ xyz[n] + BB[0][n]  for n in [0,1,2] ]
        # [U[lɍ킹W𒲐
        if (CenterBtn[CenterBtn_LX][CenterBtn_Btn].val): CU[0]+=((BB[-2][0]-BB[0][0])*CenterBtn[CenterBtn_LX][CenterBtn_Number].val/100)
        if (CenterBtn[CenterBtn_LY][CenterBtn_Btn].val): CU[1]+=((BB[-2][1]-BB[0][1])*CenterBtn[CenterBtn_LY][CenterBtn_Number].val/100)
        if (CenterBtn[CenterBtn_LZ][CenterBtn_Btn].val): CU[2]+=((BB[-2][2]-BB[0][2])*CenterBtn[CenterBtn_LZ][CenterBtn_Number].val/100)
        # IuWFNg̃}gbNXvZČʂ擾
        MAT=ob.getMatrix()
        MAT=Blender.Mathutils.Matrix(MAT[0][:],
                                     MAT[1][:],
                                     MAT[2][:],
                                     [-CU[0],-CU[1],-CU[2],1.0])
        ME.transform(MAT)
        ME.update()
        # IIuWFNgɃ}gbNXݒ
        MAT=Blender.Mathutils.Matrix(MAT[0][:],
                                     MAT[1][:],
                                     MAT[2][:],
                                     [CU[0],CU[1],CU[2],1.0])
        ob.setMatrix(MAT)
    Blender.Redraw()

def CenterRandomFunction():
    global IsCenterRndDirection
    for ob in Blender.Object.GetSelected():
        #OB=Blender.Object.GetSelected()[0]
        ME=ob.getData()
        MAT=ob.getMatrix()
        ME.transform(MAT)
        ME.update()
        # LocX,LocY,LocZ ́AIuWFNg̒S̍WŖ{̍WƂ͂܂ʂłB
        # Loc  getLocation Ɠ
        xyz=[ob.LocX,ob.LocY,ob.LocZ]
        # }gbNX
        MAT=Blender.Mathutils.Matrix([1.0,0.0,0.0,0.0],
                                     [0.0,1.0,0.0,0.0],
                                     [0.0,0.0,1.0,0.0],
                                     [0.0,0.0,0.0,1.0])
        # }gbNXݒ
        ob.setMatrix(MAT)
        # Type.2
        BB=ob.getBoundBox()
        # IuWFNg̊pW
        CU= [ xyz[n] + BB[0][n]  for n in [0,1,2] ]
        # [U[lɍ킹W𒲐
        # Shake  : ob.LocX+=GetNoiseRandom((BB[-2][0]-BB[0][0]),ShakeBtn[ShakeBtn_LX][ShakeBtn_Number].val)*IsShakeDirection
        # Center : CU[0]+=((BB[-2][0]-BB[0][0])*CenterBtn[CenterBtn_LX][CenterBtn_Number].val/100)
        if (CenterBtn[CenterBtn_LX][CenterBtn_Btn].val): CU[0]+=GetNoiseRandom((BB[-2][0]-BB[0][0]),CenterBtn[CenterBtn_LX][CenterBtn_Number].val)*IsCenterRndDirection
        if (CenterBtn[CenterBtn_LY][CenterBtn_Btn].val): CU[1]+=GetNoiseRandom((BB[-2][1]-BB[0][1]),CenterBtn[CenterBtn_LY][CenterBtn_Number].val)*IsCenterRndDirection
        if (CenterBtn[CenterBtn_LZ][CenterBtn_Btn].val): CU[2]+=GetNoiseRandom((BB[-2][2]-BB[0][2]),CenterBtn[CenterBtn_LZ][CenterBtn_Number].val)*IsCenterRndDirection
        # IuWFNg̃}gbNXvZČʂ擾
        MAT=ob.getMatrix()
        MAT=Blender.Mathutils.Matrix(MAT[0][:],
                                     MAT[1][:],
                                     MAT[2][:],
                                     [-CU[0],-CU[1],-CU[2],1.0])
        ME.transform(MAT)
        ME.update()
        # IIuWFNgɃ}gbNXݒ
        MAT=Blender.Mathutils.Matrix(MAT[0][:],
                                     MAT[1][:],
                                     MAT[2][:],
                                     [CU[0],CU[1],CU[2],1.0])
        ob.setMatrix(MAT)
    IsCenterRndDirection*=-1
    Blender.Redraw()

#=========================================================
# DrawEvent
#=========================================================
def DrawGui():
    global MenuBtn,ShakeBtn,CenterBtn,CenterRndBtn,GatherBtn
    #BaseHeight=20
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    # + Menu Button
    y-=BaseHeight*2
    MenuBtn = Draw.Menu(MenuStr, Event_Menu, x, y, MenuWidth, BaseHeight, MenuBtn.val)
    Draw.Button (BtnList[BtnList_Excute][BtnList_iStr],BtnList[BtnList_Excute][BtnList_iEvent],x+MenuWidth+8,y,BtnList[BtnList_Excute][BtnList_iWidth],BaseHeight)
    # + ey[Wɕ\{^
    x=20
    y-=BaseHeight*2
    #   - Shake
    if MenuBtn.val == Menu_Shaker:
        # Menu:Random
        k=ShakeBtnWidth+ShakeNumberWidth+SpcWidth
        for i in range(len(ShakeBtn)//2):
            # LocX..LocZ
            ShakeBtn[i][ShakeBtn_Btn]=Draw.Toggle(ShakeBtn[i][ShakeBtn_Str], Event_Toggle, x, y, ShakeBtnWidth, BaseHeight, ShakeBtn[i][ShakeBtn_Btn].val)
            if (ShakeBtn[i][ShakeBtn_Btn].val):
                ShakeBtn[i][ShakeBtn_Number]=Draw.Number('', Event_Non, x+ShakeBtnWidth+4, y, ShakeNumberWidth, BaseHeight, ShakeBtn[i][ShakeBtn_Number].val, 0, 100)
            # RotX..RotZ
            ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Btn]=Draw.Toggle(ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Str], Event_Toggle, x+k, y, ShakeBtnWidth, BaseHeight, ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Btn].val)
            if (ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Btn].val):
                ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Number]=Draw.Number('', Event_Non, x+ShakeBtnWidth+4+k, y, ShakeNumberWidth, BaseHeight, ShakeBtn[ShakeBtn_RX+i][ShakeBtn_Number].val, 0, 100)
	    y-=BaseHeight*2-(BaseHeight-4)
    #   - Center
    if MenuBtn.val == Menu_Center:
        k=ShakeBtnWidth+ShakeNumberWidth+SpcWidth
        for i in range(len(CenterBtn)):
            # X..Z
            CenterBtn[i][CenterBtn_Btn]=Draw.Toggle(CenterBtn[i][CenterBtn_Str], Event_Toggle, x, y, CenterBtnWidth, BaseHeight, CenterBtn[i][CenterBtn_Btn].val)
            if (CenterBtn[i][CenterBtn_Btn].val):
                CenterBtn[i][CenterBtn_Number]=Draw.Number('', Event_Non, x+CenterBtnWidth+4, y, ShakeNumberWidth, BaseHeight, CenterBtn[i][CenterBtn_Number].val, 0, 100)
	    y-=BaseHeight*2-(BaseHeight-4)
        CenterRndBtn=Draw.Toggle('Random', Event_Toggle, x+(CenterBtnWidth+4)*2+30, y+(BaseHeight*2-4)*2, CenterBtnWidth, BaseHeight, CenterRndBtn.val)
    #   - Gather
    if MenuBtn.val == Menu_Gather:
        k=ShakeBtnWidth+ShakeNumberWidth+SpcWidth
        for i in range(len(GatherBtn)//2):
            # LocX..LocZ
            GatherBtn[i][GatherBtn_Btn]=Draw.Toggle(GatherBtn[i][GatherBtn_Str], Event_Toggle, x, y, GatherBtnWidth, BaseHeight, GatherBtn[i][GatherBtn_Btn].val)
            if (GatherBtn[i][GatherBtn_Btn].val):
                GatherBtn[i][GatherBtn_Number]=Draw.Number('', Event_Non, x+GatherBtnWidth+4, y, ShakeNumberWidth, BaseHeight, GatherBtn[i][GatherBtn_Number].val, -10000, 10000)
            # RotX..RotZ
            GatherBtn[GatherBtn_RX+i][GatherBtn_Btn]=Draw.Toggle(GatherBtn[GatherBtn_RX+i][GatherBtn_Str], Event_Toggle, x+k, y, GatherBtnWidth, BaseHeight, GatherBtn[GatherBtn_RX+i][GatherBtn_Btn].val)
            if (GatherBtn[GatherBtn_RX+i][GatherBtn_Btn].val):
                GatherBtn[GatherBtn_RX+i][GatherBtn_Number]=Draw.Number('', Event_Non, x+GatherBtnWidth+4+k, y, ShakeNumberWidth, BaseHeight, GatherBtn[GatherBtn_RX+i][GatherBtn_Number].val, -10000, 10000)
	    y-=BaseHeight*2-(BaseHeight-4)
    # + Version
    BGL.glRasterPos2f(x+size[2]-Draw.GetStringWidth(Version+Author)-40, y)
    Draw.Text(Version+Author)
    # + Exit Button
    y-=BaseHeight*2-10
    Draw.Button (BtnList[BtnList_Exit][BtnList_iStr],BtnList[BtnList_Exit][BtnList_iEvent],x,y,BtnList[BtnList_Exit][BtnList_iWidth],BaseHeight)


#=========================================================
# ButtonEvent
#=========================================================
def ExitFunction():
    if Draw.PupMenu('Confirm.. %t|Exit Script ? %x1')==1:
        Draw.Exit()

def ExecuteFunction(i):
    if (i==Menu_Shaker)	: ShakerFunction()
    if (i==Menu_Gather)	: GatherFunction()
    if (i==Menu_Center) : 
        if (CenterRndBtn.val):
            CenterRandomFunction()
        else:
            CenterFunction()

def RegisterFunction(i):
    MenuBtn.val=i
    Draw.Register(DrawGui, KeyEvent, ButtonEvent)

def ButtonEvent(evt):
    if (evt==Event_Exit):ExitFunction()
    elif (evt==Event_Execute):
        ExecuteFunction(MenuBtn.val)
    # ĕ`őI[hɍ킹`s
    elif evt in [Event_Menu,Event_Toggle]:Draw.Register(DrawGui, KeyEvent, ButtonEvent)

#=========================================================
# KeyEvent
#=========================================================
def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :return
    if evt in [Draw.ESCKEY, Draw.QKEY]:ExitFunction()
    elif evt==Draw.XKEY:ExecuteFunction(MenuBtn.val)
    elif evt==Draw.SKEY:RegisterFunction(Menu_Shaker)
    elif evt==Draw.CKEY:RegisterFunction(Menu_Center)
    elif evt==Draw.GKEY:RegisterFunction(Menu_Gather)

#=========================================================
# Main
#=========================================================
Draw.Register(DrawGui, KeyEvent, ButtonEvent)
